<template>
    <div class='mx-6 sm:mx-14'>
        <p class='text-4xl sm:text-5xl font-bold text-xmas-gray sm:text-center'>Добре дошъл</p>
        <p class='text-sm mt-10'>Ти си на път да се включиш в страхотната инициатива на Настолни Игри - България - "Таен Дядо Коледа" за 2022!</p>
        <p class='text-sm mt-6'>Ще ни трябва малко информация за теб. Не се бой - споделяме я само с джуджетата на Дядо Коледа, а всеки знае, че GDPR е основния закон на северния полюс!</p>
        <div class='mt-5 mb-6 space-y-3'>
            <Text v-model="form.name" @blur="v$.form.name.$touch()" :invalid="v$.form.name.$error" label="Име и фамилия" required></Text>
            <Text v-model="form.email" @blur="v$.form.email.$touch()" :invalid="v$.form.email.$error" label="E-mail адрес" description="Ще си получиш данните за вход там." required></Text>
        </div>    
        <a @click='terms = !terms' class='h-7 cursor-pointer flex space-x-4 items-center mb-5 text-xmas-olive'>
            <img src='images/circle.png' v-if='! terms' class='w-6' />
            <img src='images/circle-active.png' v-if='terms' class='w-6' />
            <p class='text-xs '>Запознах се с <a class='underline' @click.stop='openTerms'>правилата и условията</a> за участие. Честно.</p>
        </a>
        <ButtonStack :disabled="v$.$invalid" @click='advance'></ButtonStack>
    </div>
</template>

<script>     
    import Text from '@/components/Text'
    import ButtonStack from '@/components/ButtonStack'
    import useVuelidate from '@vuelidate/core' 
    import { helpers, required, email, minLength, sameAs, maxLength } from '@vuelidate/validators'    

     export default {
        name: 'Step 2',
        components: {
            Text,
            ButtonStack,
        },
        data() {
            return {
                form: {
                    name    : '',
                    email   : '',
                },
                terms   : false,
            }
        },
        methods: {
            advance() {
                this.syncWithStore();
                this.$store.dispatch("register/advance")
            },
            syncWithStore() {
                this.$store.state.register.registrationData.name = this.form.name;
                this.$store.state.register.registrationData.email = this.form.email;
            },
            syncFromStore() {
                this.form.name = this.$store.state.register.registrationData.name
                this.form.email = this.$store.state.register.registrationData.email
            },
            openTerms() {
                this.syncWithStore();
                this.$router.push({ name: 'terms' })
            },
        },
        created() {
            this.syncFromStore();
        },
        setup() {
            return { v$: useVuelidate() }
        },
        validations: {
            form: {
                name: {
                    required
                },
                email: {
                    required, email
                },
            },
            terms: {
                required: sameAs(true),
            }
        }
    }
</script>